
Require Import NPeano.
Require Import Div2.

Record uint8 :=
  { g0 : bool;
    g1 : bool;
    g2 : bool;
    g3 : bool;
    g4 : bool;
    g5 : bool;
    g6 : bool;
    g7 : bool }.

Definition pow2 (n : nat) : nat := pow 2 n.
Definition grade2 (n m : nat) : bool :=
  match modulo (n/(pow2 m)) 2 with
    | 0 => false
    | _ => true
  end.


Definition uint8_of_nat (n : nat) : uint8 :=
  Build_uint8 (grade2 n 0) (grade2 n 1) (grade2 n 2) (grade2 n 3) (grade2 n 4) (grade2 n 5) (grade2 n 6) (grade2 n 7).

Definition b2n (b : bool) : nat :=
  match b with
    | false => 0
    | true => 1
  end.

Definition nat_of_uint8 (u : uint8) : nat :=
  b2n (g0 u) + b2n (g1 u) * pow2 1 + b2n (g2 u) * pow2 2 + b2n (g3 u) * pow2 3 + b2n (g4 u) * pow2 4 + b2n (g5 u) * pow2 5 + b2n (g6 u) * pow2 6 + b2n (g7 u) * pow2 7.

Definition lshift (u : uint8) : uint8 :=
  Build_uint8 false (g0 u) (g1 u) (g2 u) (g3 u) (g4 u) (g5 u) (g6 u).


Lemma lshift_time2 : forall (b : bool), nat_of_uint8 (lshift (Build_uint8 b false false false false false false false)) = 2 * nat_of_uint8 (Build_uint8 b false false false false false false false).
Proof.
  intros.
  destruct b.
  - simpl.
    unfold lshift.
    simpl.
    unfold nat_of_uint8.
    simpl.
    now reflexivity.
  - simpl; unfold lshift; simpl; unfold nat_of_uint8; simpl; now reflexivity.
Qed.

Compute uint8_of_nat 0.
Compute uint8_of_nat 1.
Compute uint8_of_nat 2.
Compute uint8_of_nat 3.
Compute uint8_of_nat 4.
Compute uint8_of_nat 5.
Compute uint8_of_nat 6.
Compute uint8_of_nat 7.
Compute uint8_of_nat 8.
Compute uint8_of_nat 255.

Definition addb (a b c : bool) : bool := xorb (xorb a b) c.
Definition carry (a b c : bool) : bool := orb (andb a b) (orb (andb a c) (andb b c)).

Definition add_uint8 (u1 u2 : uint8) : uint8 :=
  let c1 := andb (g0 u1) (g0 u2) in
  let c2 := carry (g1 u1) (g1 u2) c1 in
  let c3 := carry (g2 u1) (g2 u2) c2 in
  let c4 := carry (g3 u1) (g3 u2) c3 in
  let c5 := carry (g4 u1) (g4 u2) c4 in
  let c6 := carry (g5 u1) (g5 u2) c5 in
  let c7 := carry (g6 u1) (g6 u2) c6 in
  Build_uint8 (xorb (g0 u1) (g0 u2)) (addb (g1 u1) (g1 u2) c1) (addb (g2 u1) (g2 u2) c2) (addb (g3 u1) (g3 u2) c3) (addb (g4 u1) (g4 u2) c4) (addb (g5 u1) (g5 u2) c5) (addb (g6 u1) (g6 u2) c6) (addb (g7 u1) (g7 u2) c7).    
  

Require Import ExtrOcamlNatInt.
Extraction "uint8.ml" uint8_of_nat nat_of_uint8 add_uint8.