type ('a, 'b) prod =
| Pair of 'a * 'b

(** val add_v :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a1) prod -> ('a1, 'a1) prod -> ('a1, 'a1)
    prod **)

let add_v add u v =
  let Pair (u1, u2) = u in
  let Pair (v1, v2) = v in Pair ((add u1 v1), (add u2 v2))

(** val add_f :
    ('a1 -> 'a1 -> 'a1) -> (('a1, 'a1) prod -> 'a1) -> (('a1, 'a1) prod ->
    'a1) -> ('a1, 'a1) prod -> 'a1 **)

let add_f add f g u =
  add (f u) (g u)

(** val mul_v :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a1) prod -> ('a1, 'a1) prod **)

let mul_v mul c = function
| Pair (u1, u2) -> Pair ((mul c u1), (mul c u2))

(** val mul_f :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> (('a1, 'a1) prod -> 'a1) -> ('a1, 'a1) prod
    -> 'a1 **)

let mul_f mul c f u =
  mul c (f u)

