
(* 発展編 : x 軸方向を往復するアニメーション *)
let timer = ref 0
let vertecies_org = [-1., -1.; -1., 1.; 1., 1.; 1., -1.] 

(* ここに平面ベクトルの計算を定義します. *)
open Vec2dbase
let ( +& ) (u1,u2) (v1,v2) =
  match add_v2 ( +. ) (Pair (u1,u2)) (Pair (v1,v2)) with
  | Pair (w1, w2) -> (w1,w2)
      
let ( *< ) c (v1,v2) =
  match mul_v2 ( *. ) c (Pair (v1,v2)) with
  | Pair (w1, w2) -> (w1,w2)

let motion (dx, dy) (x, y) = (dx, dy) +& (x, y)
let vertecies (dx, dy) = List.map (motion (dx, dy)) vertecies_org
    
(* アニメーション部 *)
    
let () =
  ignore (Glut.init Sys.argv);
  Glut.initDisplayMode ~double_buffer:true ();
  Glut.initWindowSize ~w:512 ~h:512;
  ignore (Glut.createWindow ~title:"OpenGL 2D Demo with Coq Extraction");
  GlClear.color (0., 0., 0.);
  GlDraw.shade_model `smooth;
  let render () =
    let dx =
      if !timer <= 50 then (float !timer) *. 0.04
      else if 50 < !timer && !timer <= 150 then (float (100 - !timer)) *. 0.04
      else (float (!timer - 200)) *. 0.04
    in
    let dy = 0. in

    GlMat.mode `projection;
    GlMat.load_identity ();
    GluMat.ortho2d ~x:(-5., 5.) ~y:(-5., 5.);
    GlMat.mode `modelview;
    GlMat.load_identity ();
    GlClear.clear [ `color ];
    GlDraw.begins `quads;
    List.iter GlDraw.vertex2 (vertecies (dx, dy));
    GlDraw.ends ();
    Gl.flush ();
    timer := if !timer < 200 then !timer+1 else 0;
    Glut.swapBuffers ()
  in
  Glut.displayFunc ~cb:render;
  Glut.idleFunc ~cb:(Some Glut.postRedisplay);
  Glut.keyboardFunc ~cb:(fun ~key ~x ~y -> if key=27 then exit 0);
  Glut.mainLoop ()
