
Section F_vec2.

  Variable F : Type.
  Variable add mul : F->F->F.
  Axiom assoc_add : forall (a b c : F), add a (add b c) = add (add a b) c.
  Axiom comm_add : forall (a b : F), add a b = add b a.
  Axiom assoc_mul : forall (a b c : F), mul a (mul b c) = mul (mul a b) c.
  Axiom comm_mul : forall (a b : F), mul a b = mul b a.
  
  Definition add_v2 (u v : F*F) : F*F :=
    ((add (fst u) (fst v)), (add (snd u) (snd v))).

  Definition mul_v2 (c : F) (u : F*F) : F*F :=
    ((mul c (fst u)), (mul c (snd u))).

  Lemma comm_add_v2 : forall (u v : F*F), add_v2 u v = add_v2 v u.
  Proof.
    intros.
    unfold add_v2.
    rewrite comm_add.
    assert (add (snd u) (snd v) = add (snd v) (snd u)).
    - rewrite comm_add.
      reflexivity.
    - rewrite H.
    reflexivity.
  Qed.

  Lemma assoc_mul_v2 : forall (a b : F) (u : F*F), mul_v2 (mul a b) u = mul_v2 a (mul_v2 b u).
  Proof.
    intros.
    unfold mul_v2.
    simpl.
    rewrite assoc_mul.
    assert (mul (mul a b) (snd u) = mul a (mul b (snd u))).
    - rewrite assoc_mul.
      reflexivity.
    - rewrite H.
      reflexivity.
  Qed.

End F_vec2.

Extraction "vec2dbase_n.ml" add_v2 mul_v2.